var get_list_of_sub_conditions = function () {
    var sub_conditions = appData.sub_conditions;
    var list_of_sub_actions = [];

    for (var sub_condition_index in sub_conditions) {
        list_of_sub_actions.push(sub_conditions[sub_condition_index].name);
    }

    return list_of_sub_actions;
};

var get_sub_condition_obj_by_name = function (sub_condition_name) {
    var sub_conditions = appData.sub_conditions;
    var obj = null;

    for (var i = 0; i < sub_conditions.length; i++) {
        if (sub_conditions[i].name === sub_condition_name) {
            obj = sub_conditions[i];
            break;
        }
    }

    return obj;
};

var set_all_sub_conditions_container_hidden = function () {
    templateObj.$.ti_widget_container_sub_condition_empty.visible = true;

    templateObj.$.ti_widget_container_sub_conditions_none.visible = false;
    templateObj.$.ti_widget_container_started_role.visible = false;
    templateObj.$.ti_widget_container_counter_value.visible = false;
    templateObj.$.ti_widget_container_gpio_state.visible = false;
};

var onSubConditionSelected = function () {
    var device_type = templateObj.$.ti_widget_droplist_device_type.selectedText;

    var selectedValue = templateObj.$.ti_widget_droplist_sub_conditions.selectedText;
    console.log(selectedValue);

    set_all_sub_conditions_container_hidden();

    if (selectedValue) {
        templateObj.$.ti_widget_container_sub_condition_empty.visible = false;

        switch (selectedValue) {
            case "None": // Always true
                templateObj.$.ti_widget_container_sub_conditions_none.style.left = sub_condition_pos_left;
                templateObj.$.ti_widget_container_sub_conditions_none.style.top = sub_condition_pos_top;

                templateObj.$.ti_widget_container_sub_conditions_none.visible = true;
                break;
            case "Started role": // Started role
                templateObj.$.ti_widget_container_started_role.style.left = sub_condition_pos_left;
                templateObj.$.ti_widget_container_started_role.style.top = sub_condition_pos_top;

                templateObj.$.ti_widget_container_started_role.visible = true;
                break;
            case "Counter value": // Counter value
                templateObj.$.ti_widget_container_counter_value.style.left = sub_condition_pos_left;
                templateObj.$.ti_widget_container_counter_value.style.top = sub_condition_pos_top;

                templateObj.$.ti_widget_container_counter_value.visible = true;
                break;
            case "GPIO state": // GPIO state
                templateObj.$.ti_widget_droplist_gpio_state_pad_num.labels = get_input_pad_numbers(device_type);

                templateObj.$.ti_widget_container_gpio_state.style.left = sub_condition_pos_left;
                templateObj.$.ti_widget_container_gpio_state.style.top = sub_condition_pos_top;

                templateObj.$.ti_widget_container_gpio_state.visible = true;
                break;
        }
    }

};

var getDataForSubCondition = function (rule) {
    var selectedIndex = templateObj.$.ti_widget_droplist_sub_conditions.selectedIndex;
    var selectedText = templateObj.$.ti_widget_droplist_sub_conditions.selectedText;

    if (selectedIndex === -1) {
        alert("Please select Sub Condition before continue forward");
        return undefined;
    }

    var sub_condition_obj = get_sub_condition_obj_by_name(selectedText);

    rule.sub_condition = {
        "name": "sub condition id",
        "raw_val": selectedIndex,
        "val": sub_condition_obj.id,
        "size": 4
    };
    rule.sub_condition_value = {
        "name": "sub condition value",
        "raw_val": "",
        "val": "",
        "size": 4
    };

    rule.sub_condition_params = []

    switch (selectedText) {
        case "None":

            break;

        case "Started role":
            rule.sub_condition_value.raw_val = templateObj.$.ti_widget_droplist_started_role_code.selectedIndex;
            rule.sub_condition_value.val = "0x" + templateObj.$.ti_widget_droplist_started_role_code.selectedIndex.toString();

            break;

        case "Counter value":
            var counter_number = {
                "name": "counter_number",
                "raw_val": templateObj.$.ti_widget_droplist_counter_value_number.selectedIndex,
                "val": "",
                "size": -1
            };
            rule.sub_condition_params.push(counter_number);

            var counter_compare = {
                "name": "counter_compare",
                "raw_val": templateObj.$.ti_widget_droplist_counter_value_compare.selectedIndex,
                "val": "",
                "size": -1
            };
            rule.sub_condition_params.push(counter_compare);

            rule.sub_condition.val = rule.sub_condition.val.replace("NN", zeroPad(templateObj.$.ti_widget_droplist_counter_value_number.selectedIndex.toString(16), 2));
            rule.sub_condition.val = rule.sub_condition.val.replace("CCC", zeroPad(templateObj.$.ti_widget_droplist_counter_value_compare.selectedIndex.toString(), 3));

            rule.sub_condition_value.raw_val = templateObj.$.ti_widget_numberbox_counter_value_value.value;
            rule.sub_condition_value.val = "0x" + templateObj.$.ti_widget_numberbox_counter_value_value.value.toString(16);

            break;

        case "GPIO state":
            var pad_num = {
                "name": "pad_num",
                "raw_val": templateObj.$.ti_widget_droplist_gpio_state_pad_num.selectedIndex,
                "val": "",
                "size": -1
            };
            rule.sub_condition_params.push(pad_num);

            var pull = {
                "name": "pull",
                "raw_val": templateObj.$.ti_widget_droplist_gpio_state_pull.selectedIndex,
                "val": "",
                "size": -1
            };
            rule.sub_condition_params.push(pull);

            rule.sub_condition.val = rule.sub_condition.val.replace("NN", zeroPad(parseInt(templateObj.$.ti_widget_droplist_gpio_state_pad_num.selectedText).toString(16), 2));
            rule.sub_condition.val = rule.sub_condition.val.replace("PP", zeroPad(templateObj.$.ti_widget_droplist_gpio_state_pull.selectedIndex.toString(16), 2));

            rule.sub_condition_value.raw_val = templateObj.$.ti_widget_droplist_gpio_state_value.selectedIndex;
            rule.sub_condition_value.val = "0x" + templateObj.$.ti_widget_droplist_gpio_state_value.selectedIndex.toString(16);

            break;
    }

    return rule;
};

var loadDataForSubConditions = function (rule) {

    templateObj.$.ti_widget_droplist_sub_conditions.selectedIndex = rule.sub_condition.raw_val;
    onSubConditionSelected();

    var selectedText = templateObj.$.ti_widget_droplist_sub_conditions.selectedText;
    switch (selectedText) {
        case "None":
            break;

        case "Started role":
            templateObj.$.ti_widget_droplist_started_role_code.selectedIndex = rule.sub_condition_value.raw_val;

            break;

        case "Counter value":
            templateObj.$.ti_widget_droplist_counter_value_number.selectedIndex = get_value_by_name(rule.sub_condition_params, "counter_number");

            templateObj.$.ti_widget_droplist_counter_value_compare.selectedIndex = get_value_by_name(rule.sub_condition_params, "counter_compare");

            templateObj.$.ti_widget_numberbox_counter_value_value.value = rule.sub_condition_value.raw_val;

            break;

        case "GPIO state":
            templateObj.$.ti_widget_droplist_gpio_state_pad_num.selectedIndex = get_value_by_name(rule.sub_condition_params, "pad_num");

            templateObj.$.ti_widget_droplist_gpio_state_pull.selectedIndex = get_value_by_name(rule.sub_condition_params, "pull");

            templateObj.$.ti_widget_droplist_gpio_state_value.selectedIndex = rule.sub_condition_value.raw_val;

            break;
    }

};
