


var pack = function(data, size) {
    if (data.startsWith('0x')) {
        data = data.substr(2);
    }
    
    if (data.length % 2 !== 0) {
        data = '0' + data;
    }

    var pad_counter = size - (data.length / 2);
    
    var out = "";
    for(var i = data.length; i > 0; i = i - 2) {
        out += String.fromCharCode(parseInt(data.substr(i-2, 2), 16));
    }

    for (var y = 0; y < pad_counter; y++){
        out += String.fromCharCode(0);
    }

    return out;
};  

var zeroPad = function(num, places) {
  var zero = places - num.toString().length + 1;
  return Array(+(zero > 0 && zero)).join("0") + num;
}

var getContentForRule = function(rule) {
    var content = "";
    
    console.log(rule);
    
    // Adding primary conditions type 
    content += pack(rule.primary_conditions_type.val, rule.primary_conditions_type.size);
    
    // Adding primary conditions length
    content += pack(rule.primary_conditions_length.val, rule.primary_conditions_length.size);
    
    // Adding sub condition type and parameters
    content += pack(rule.sub_condition.val, rule.sub_condition.size);
    
    // Adding sub condition value
    content += pack(rule.sub_condition_value.val, rule.sub_condition_value.size);
    
    // Adding extra primary conditions parameters
    rule.primary_conditions_params.forEach(function(param) {
        if (param.size > 0) {
            content += pack(param.val, param.size);
        }
    });

    // Adding action type 
    content += pack(rule.action_type.val, rule.action_type.size);
    
    // Adding action length
    content += pack(rule.action_length.val, rule.action_length.size);
    
    // Adding reaction parameters
    rule.action_params.forEach(function(param) {
        if (param.size > 0) {
            content += pack(param.val, param.size);
        }
    });
    
    return content;
};

var addTermination = function(content) {
    var updated_content = content;
    
    updated_content += pack("0", 4);
    updated_content += pack("0", 4);
    updated_content += pack("0", 4);

    return updated_content;
};

var get_value_by_name = function(params, field_name) {
    var ret = "";
    
    for(var i = 0; i < params.length; i++){
        if (params[i].name === field_name){
            ret = params[i].raw_val;
            break;
        }
    }

    return ret;
};

var arraymove = function(arr, fromIndex, toIndex) {
    var element = arr[fromIndex];
    arr.splice(fromIndex, 1);
    arr.splice(toIndex, 0, element);
};


var checkIsIPV4 = function(entry) {
  var blocks = entry.split(".");
  if(blocks.length === 4) {
    return blocks.every(function(block) {
      return parseInt(block,10) >=0 && parseInt(block,10) <= 255;
    });
  }
  return false;
}

var convertIPV4toHex = function(entry) {
  var blocks = entry.split(".");
  if(blocks.length === 4) {
      var ret = "0x"
      for(var i = 0; i < blocks.length; i++){
          ret += zeroPad(parseInt(blocks[i]).toString(16), 2);
      }
      return ret;
  }
  return ""
}
